// Ryan Zhou
// Fab Academy 2024
// Charlotte Latin Fab Lab
// Licensed with the Fab License

// (c) 06/01/2024

// This work may be reproduced, modified, distributed, performed, and displayed for any purpose, but must acknowledge "motorized lazy susan". Copyright is retained and must be preserved. The work is provided as is; no warranty is provided, and users accept all liability.

const int stepPin = 1;
const int dirPin = 2;
const int potPin = 26;

const int stepsPerRevolution = 200;  // Number of steps per revolution for NEMA 17 motor

void setup() {
  pinMode(stepPin, OUTPUT);
  pinMode(dirPin, OUTPUT);
  pinMode(potPin, INPUT);
  digitalWrite(dirPin, HIGH);  // Sets direction
}

void loop() {
  int potValue = analogRead(potPin);

  // Map the potentiometer value to a speed range (RPM)
  float minRPM = 10.0;
  float maxRPM = 30.0;
  float rpm = map(potValue, 0, 1023, minRPM * 100, maxRPM * 100) / 100.0;

  // Calculate the delay between steps in microseconds
  float stepsPerMinute = rpm * stepsPerRevolution;
  float stepsPerSecond = stepsPerMinute / 60.0;
  float delayBetweenSteps = 1000000.0 / stepsPerSecond;

  // Calculates movement
  digitalWrite(stepPin, HIGH);
  delayMicroseconds(delayBetweenSteps / 2);
  digitalWrite(stepPin, LOW);
  delayMicroseconds(delayBetweenSteps / 2);
}